<?php
function buildExif($file) {
	if (function_exists( 'exif_read_data' )) {	// Check if the function exists so no fatal error takes place
		$exif = @exif_read_data($file, 0, true);		// @ supresses warnings for Cannon images

		$output['filename'] 		= $exif['FILE']['FileName'];
		$output['orientation']	= $exif['IFD0']['Orientation'];
		$output['date']					= $exif['EXIF']['DateTimeOriginal'];
		$output['iso']					= $exif['EXIF']['ISOSpeedRatings'];
		if (isset($exif['EXIF']['FNumber'])) {
			$temp = explode("/", $exif['EXIF']['FNumber']);
			$output['apature']			= $temp[0]/$temp[1];
		}
		else { $output['apature'] = $exif['EXIF']['FNumber']; }
		$output['camera']				= $exif['IFD0']['Model'];
		$output['focal']				= substr_replace($exif['EXIF']['FocalLength'],"",-2);
		$output['comment']			= $exif['COMPUTED']['UserComment'];
		$output['height']				= $exif['COMPUTED']['Height'];
		$output['width']				= $exif['COMPUTED']['Width'];
	
	// {{{ GPS Cooridnates
	if (isset($exif['GPS']['GPSLongitude'][0])) {
		$output['latDirection']				= $exif['GPS']['GPSLatitudeRef'];
			$temp = explode("/", $exif['GPS']['GPSLatitude'][0]);
		$output['latDegrees']			= $temp[0] / $temp[1];				// Negative if West
			$temp = explode("/", $exif['GPS']['GPSLatitude'][1]);
		$output['latMinutes']     = $temp[0] / $temp[1];
			$temp = explode("/", $exif['GPS']['GPSLatitude'][2]);
		$output['latSeconds']					= $temp[0] / $temp[1];
		
		$output['longDirection'] 			= $exif['GPS']['GPSLongitudeRef'];
			$temp = explode("/", $exif['GPS']['GPSLongitude'][0]);
		$output['longDegrees']        = $temp[0] / $temp[1];		// Positive if North
			$temp = explode("/", $exif['GPS']['GPSLongitude'][1]);
		$output['longMinutes']				= $temp[0] / $temp[1];
			$temp = explode("/", $exif['GPS']['GPSLongitude'][2]);
		$output['longSeconds']				= $temp[0] / $temp[1];
	
		if ($output['latDirection'] != "N") { $output['geoCoords'] = "-"; }
			$output['geoCoords'] .= ($output['latDegrees'] + ($output['latMinutes']/60) + ($output['latSeconds']/3600)) . ", "; 
		if ($output['longDirection'] != "E") { $output['geoCoords'] .= "-"; }
			$output['geoCoords'] .= ($output['longDegrees'] + ($output['longMinutes']/60) + ($output['longSeconds']/3600));

		$output['gmapsLink'] 		= "http://maps.google.com/maps?q=" . $output['geoCoords'] . "&t=h&hl=en&ie=UTF8";
		$output['gmapsEmbed']		= "<iframe width=\"425\" height=\"300\" frameborder=\"0\" scrolling=\"no\" marginheight=\"0\" marginwidth=\"0\" src=\"" . $output['gmapsLink'] . "&amp;spn=0,0&amp;z=16&amp;output=embed\"></iframe>";
	}
	// }}}
	}

	return $output;
}
?>
