<?php require_once('inc/variables.php'); ?>
<?php
	if ($protected == 1)			// If the album is set to protected
		require_once('inc/protect.php'); 
?>
<!--
	Script:   ThePhig
	Link:   http://www.thephig.com/
	Version:  <?php echo $version . "\n"; ?>
-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns='http://www.w3.org/1999/xhtml'>
	<head>
		<title><?php echo $galleryTitle; ?></title>
		<?php require_once("inc/includes.php"); ?>
		<?php include("template/$theme/htmlHead.php"); ?>
	</head>
	<body onunload="GUnload()">

<?php
		// {{{ View Specific Image
		if ($imageID) {
			$albumFolder = $imageInfo['albumFolder'];
			$imageName = $imageInfo['imageName'];
			
			// The session storing is required for taking the output now and displaying in later in the script
			ob_start();
				include("template/$theme/singleImage.php");
				$albumEntry = ob_get_contents();	// Store buffer content into variable
			ob_end_clean();	// Clear the buffer
		}
		// }}}
		// {{{ View Album
		else if ($albumID || $tags) {
			// {{{ Build image links and gmap markers
			// Store the following output for displaying later
			ob_start();
			while ($imageInfo = mysql_fetch_array($result)) {
				$albumFolder = $imageInfo['albumFolder'];
				$gmap = $imageInfo['gmap'];
				$imageName = $imageInfo['imageName'];
				$resizeName = substr($imageName, 0, -4) . "_resize." . substr($imageName, strrpos($imageName , ".") +1);
				$geoCoords = $imageInfo['geoCoords'];
				$imageTitle = $imageInfo['imageTitle'];
				$thumbnailImage = "$imagesPath/$albumFolder/" . $imageInfo['thumbnailName'];
				$resizedImage = "$imagesPath/$albumFolder/$resizeName";
				$originalImage = "$imagesPath/$albumFolder/$imageName";
				
				// Check to see if the resized image is available, otherwise display original image
				if ( file_exists($resizedImage) ) { $imageLink = $resizedImage; }
				else { $imageLink = $originalImage; }

				if ( !$imageTitle ) { $imageTitle = $imageName; }
				
			
				// Only display the image and information if the thumbnail exists
				if (file_exists($thumbnailImage)) {
					// Store the Google Maps markers as long as google maps has been enabled in the admin panel and geocoords are not empty
					if ( ($gmap != 0) && ($geoCoords != '') ) {
						$gmapMarker .= 	"\n\nvar point = new GLatLng($geoCoords); " .
														"\nvar marker = createMarker(point,'" .
														"<div class=\"marker\"><a href=\"$imageLink\" title=\"" . addslashes($imageTitle) . "\" target=\"_blank\">" . addslashes($imageTitle) . "<br /><img src=\"$thumbnailImage\" alt=\"$imageName\" /></a> </div>') " .
														"\nmap.addOverlay(marker); ".
														"\nbounds.extend(marker.getPoint());";
					}
					$imageTitle = stripslashes($imageTitle);
					include("template/$theme/imageEntry.php");
				}
			}
			$albumEntry = ob_get_contents();	// Store buffer content into variable
			ob_end_clean();										// Clear the buffer
			// }}}
			// {{{ Google Map
			// As long as $apiKey is not empty, display the Google Map for the album
			if ($apiKey != "") {
				$googleMap = "
				<script type=\"text/javascript\" src=\"http://maps.google.com/maps?file=api&amp;v=2&amp;key=$apiKey\"></script>
				<div id=\"map\" style=\"width:100%; height:400px;\"></div>
				<script type=\"text/javascript\">
					if (GBrowserIsCompatible()) {
						function createMarker(point,html) {
							var marker = new GMarker(point);
							GEvent.addListener(marker, \"click\", function() {
								marker.openInfoWindowHtml(html);
							});
							return marker;
						}
							
						var bounds = new GLatLngBounds();
						var map = new GMap2(document.getElementById(\"map\"));
						map.addControl(new GSmallMapControl());     // Control Displays
						map.addControl(new GMapTypeControl());      // Show Sattelite, Map, or Hybrid buttons
						map.setCenter(new GLatLng(0,0),0);
						//map.setMapType(G_NORMAL_MAP);             // Normal View
						map.setMapType(G_HYBRID_MAP);               // Hybrid View
						//map.setMapType(G_PHYSICAL_MAP);           // Terrain View (Does not allow far zooming)
						map.enableScrollWheelZoom();" .
								
						$gmapMarker . "
						
						map.setZoom(map.getBoundsZoomLevel(bounds));
						map.setCenter(bounds.getCenter());
					}
				</script>";
			}
			else { $googleMap = "<div id=\"map\">Google Maps API Key is has not been set</div>"; }
			// }}}
		}
		// }}}
		// {{{ Default View
		else {
			ob_start();		// Start a buffer to store the contents
			while ($albums = mysql_fetch_array($result)) {		// Read database for albums
				$albumName = $albums['albumName'];
				$albumFolder = $albums['albumFolder'];
				$albumDate = $albums['albumDate'];
				$albumDesc = $albums['albumDesc'];
				$albumID = $albums['albumID'];
				$albumProtected = (int)$albums['protected'];
			
				// Build the album icon
				if (file_exists($_SERVER['DOCUMENT_ROOT'] . '/' . $galleryPath . $imagesPath . '/' . $albumFolder . '/icon.png'))
					$albumIcon = "$galleryPath$imagesPath/$albumFolder/icon.png";
				else
					$albumIcon = "$galleryPath$imagesPath/icon-blank.png";
				
				// Build the album link
				$albumLink = "?albumID=$albumID";
					if ($debug == 1) { $albumLink .= "&debug=1"; }

				if ( (file_exists($_SERVER['DOCUMENT_ROOT'] . '/' . $galleryPath . $imagesPath . '/' . $albumFolder)) && $albums['visible'] == 1 ) {
					include("template/$theme/albumEntry.php");
				}
			}
			$albumEntry = ob_get_contents();	// Store buffer content into variable
			ob_end_clean();	// Clear the buffer
		}
		// }}}
	?>

		<?php include("template/$theme/header.php"); ?>
		<div id="gallery">
			<?php
			if ( !$albumID && !$tags ) { echo "<div id=\"galleryAlbums\">"; }
			else { echo "<div id=\"galleryImages\">"; }
			if ($albumID && $gmap == 1) { echo $googleMap; }
			if ($numOfRows == 0) {
				echo "<h4 style=\"text-align: center; color: red;\">";
				// AlbumID doesn't exist
				if ($albumID)
					echo "Album ID $albumID does not exist.  Better luck next time";
				// Apparently the database has no albums in it.  Oops.
				else
					echo "There are currently no albums in the database.  Please add your albums to the database through the <a href=\"admin.php\" title=\"Admin Panel\">Admin Panel</a>";
				echo "</h4></div>";
			}
else
				echo $albumEntry . $pagination . "\n</div>";
			?>
		</div>
	<?php	// {{{ Debug Info
		if ($debug == 1) {
			$memoryFinal = round((memory_get_usage()/1024),2) . " KB \n";
			$execTime = round(microtime(true) - $execTime,5) . "s";
			$cpu = getrusage();
			echo "<div style=\" background: #ccc; color: #444; position: absolute; position: fixed; bottom: 0; right: 0; text-align: left; border: 1px solid black; display: block; font-size: 0.8em; padding: 5px; \">
				Number of elements: $numOfRows<br />
				Memory Init: $memoryInit<br />
				Memory Final: $memoryFinal<br />
				User Time: " . ($cpu['ru_utime.tv_sec'] + $cpu['ru_utime.tv_usec'] / 1000000) . "s<br />
				System Time: " . ($data['ru_stime.tv_sec'] + $cpu['ru_stime.tv_usec'] / 1000000) . "s<br />
				Time to execute: $execTime
			</div>";
		}
	// }}} ?>

	<?php include("template/$theme/footer.php"); ?>
